package com.boocax.client.tcp;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.ClosedChannelException;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.SocketChannel;
import java.util.Iterator;
import java.util.List;

import com.boocax.client.tcp.help.SendCommand;
import com.boocax.client.tcp.help.SendUtil;

public class TCP_CONN {

	public static Selector selector; // TCP连接所需的三个类
	public static SocketChannel channel; // TCP连接所需的三个类
	public static SelectionKey key; // TCP连接所需的三个类

	public static boolean recvFailed = false;// 通过executeRecvMessage
												// 是否收到登录验证的failed(针对于需要用户名和密码登录的Server)
	public static String processResult; // processMessage返回结果;
	public static List<String> filterList; // 过滤掉的传感器的列表
	private static int select_recvInt; // selector.select()返回的指数
	public static boolean loopMark = true; // 主循环标记

	private static ByteBuffer buffer_head; // Json head 缓冲区
	private static ByteBuffer buffer_body; // Json body 缓冲区
	private static byte[] byte_head; // Json head 数组
	private static byte[] byte_body; // Json body 数组

	private static long timeOut;// -----重连时间(超时时间)

	// 四字节代表body长度
	private static int headNum1;
	private static int headNum2;
	private static int headNum3;
	private static int headNum4;

	private static String partMsg; // 分段收到的部分的Json
	private static int bodyLength; // head读出的的Json body的长度
	private static int jsonPosition; // 缓冲区的位置

	private static String oneJsonMsg = ""; // Server发来的Json串

	private static int nullTime; // 当select>0 且未收到Json 的次数;
	private static int loopTime = 0; // 连接计数(循环里的未可读select==0)
	private static final int tryReSend = 3; // (0~3)发送请求get_allRobot_info

	private static final String NORMAL = "正常";
	public static final String CHONGLIAN = "重连";
	private static final String CHONGFA = "重发";

	private static final String NORMALSTATUS = "normal";// 正常状态
	private static final String EXCEPTIONSTATUS = "exception";// 网络异常
	private static final String OVERTIMESTATUS = "overtime"; // 网络超时
	private static String CONNSTATUS = "";

	public static boolean innerLoop = true; // 循环解析Json (一条一条)

	public static boolean isSendReconn = true; // 是否开启重连功能

	private static final long reconnTime = 3000; // 重连时间
	private static String sendContents; // SDK向上层应用传递信息的内容

	public static String mac_address;// 客户端的mac地址 获取其他唯一标识

	// public static void main(String[] args) {
	// doTCPLoop("192.168.0.79", "", "", "");
	// }

	/**
	 * 请求TCP连接
	 */
	private static String executeConn(String robotIP, String username, String pwd, String salt) {
		// 建立TCP连接
		String connResult = null;
		try {
			if (channel != null) {
				channel.close();
				channel = null;
			}
			if (key != null) {
				key.cancel();
				key = null;
			}
			if (selector != null) {
				selector = null;
			}
			recvFailed = false; // 重连的时候初始化
								// recvFailed是false(即没有收到注册反馈失败)----必须再次赋值为false
			channel = SocketChannel.open();
			channel.configureBlocking(false);
			selector = Selector.open();
			channel.connect(new InetSocketAddress(robotIP, 6789));
			channel.register(selector, SelectionKey.OP_CONNECT);
			int select = selector.select(2000);
			if (select > 0) {

				Iterator ite = selector.selectedKeys().iterator();
				key = (SelectionKey) ite.next();
				ite.remove();
				if (key.isConnectable()) {
					channel = (SocketChannel) key.channel();
					if (channel.isConnectionPending()) {
						channel.finishConnect();
					}
					channel.configureBlocking(false);
					connResult = NORMAL;
				}
			} else {
				connResult = CHONGLIAN;
			}
		} catch (java.net.ConnectException e) {
			connResult = CHONGLIAN;
		} catch (java.lang.IllegalArgumentException e) {
			connResult = CHONGLIAN;
		} catch (java.nio.channels.ClosedChannelException e) {
			connResult = CHONGLIAN;
		} catch (java.nio.channels.CancelledKeyException e) {
			connResult = CHONGLIAN;
		} catch (java.nio.channels.ConnectionPendingException e) {
			connResult = CHONGLIAN;
		} catch (IOException e) {
			connResult = CHONGLIAN;
		} catch (java.util.ConcurrentModificationException e) {
			connResult = CHONGLIAN;
		} catch (java.util.NoSuchElementException e) {
			connResult = CHONGLIAN;
		} catch (java.lang.NullPointerException e) {
			connResult = CHONGLIAN;
		} catch (java.lang.AssertionError error) {
			connResult = CHONGLIAN;
		}
		return connResult;
	}

	/**
	 * 发送注册信息;请求所有文件;
	 */
	private static String executeProcess(String username, String pwd, String salt) {
		processResult = NORMAL; // 返回值为NORMAL;

		SendCommand.sendRegister_verify(username, pwd, salt, channel); // 注册客户端
		SendCommand.sendGetAllFile(channel); // 请求所有文件
		SendCommand.sendMove("00:07:32:18:34:9D", 0, 0, 0.2, channel);// mac_address为机器人mac地址,需要从server返回值解析获取
		return processResult;
	}

	/**
	 * 接收一条Json信息的准备方法---防止SocketChannel的多次注册
	 */
	private static String executeRecvPrepare() {
		// 接收一条完整信息
		String RecvPrepareResult = null;
		try {
			channel.register(selector, SelectionKey.OP_READ);
			RecvPrepareResult = NORMAL;
		} catch (ClosedChannelException e) {
			RecvPrepareResult = CHONGLIAN;
			e.printStackTrace();
		}
		return RecvPrepareResult;// 返回消息
	}

	/**
	 * 接收一条Json数据
	 */
	private static String executeRecvMessage(String robotIP, String username, String pwd, String salt) {
		String recvMessageResult = "";

		try {
			select_recvInt = selector.select(2000);
			if (select_recvInt > 0 && loopMark) {
				Iterator ite = selector.selectedKeys().iterator();
				while (ite.hasNext() && loopMark) {
					key = (SelectionKey) ite.next();
					ite.remove();
					if (key.isReadable() && (System.currentTimeMillis() - timeOut) < 5000) {
						buffer_head = ByteBuffer.allocate(4);
						while (buffer_head.position() < 4) {
							channel.read(buffer_head);
						}
						byte_head = buffer_head.array();
						headNum1 = byte_head[0] & 0xFF;
						headNum2 = ((byte_head[1] << 8) & 0xFF00);
						headNum3 = ((byte_head[2] << 16) & 0xFF0000);
						headNum4 = ((byte_head[3] << 24) & 0xFF000000);
						bodyLength = headNum1 + headNum2 + headNum3 + headNum4;
						if (bodyLength > 3145728) { // 如果收到的Json过大
							while (bodyLength > 0) {
								if (bodyLength < 40960) {
									buffer_body = ByteBuffer.allocate(bodyLength); // 分配一个新的字节缓冲区
									channel.read(buffer_body); // 从channel中读取
									byte_body = buffer_body.array(); // 返回实现此缓冲区的
																		// byte
																		// 数组
									jsonPosition = buffer_body.position(); // 返回次缓冲区的位置
									partMsg = new String(byte_body).trim(); // 将
																			// byte
																			// 转换成
																			// String
									bodyLength -= jsonPosition; // 计算body待接收的长度
									if (partMsg.length() != 0) {
										oneJsonMsg = null;
									}
								} else {
									buffer_body = ByteBuffer.allocate(40960);
									byte_body = buffer_body.array();
									channel.read(buffer_body);
									partMsg = new String(byte_body).trim();
									jsonPosition = buffer_body.position();
									bodyLength -= jsonPosition;
									if (partMsg.length() != 0) {
										oneJsonMsg = null;
									}
								}
							}
						} else { // 如果收到的Json小于阈值; 继续正常执行
							while (bodyLength > 0) {
								if (bodyLength < 40960) {
									buffer_body = ByteBuffer.allocate(bodyLength);
									channel.read(buffer_body);
									byte_body = buffer_body.array();
									jsonPosition = buffer_body.position();
									partMsg = new String(byte_body).trim();
									bodyLength -= jsonPosition;
									if (partMsg.length() != 0) {
										oneJsonMsg = oneJsonMsg + partMsg;
									}
								} else {
									buffer_body = ByteBuffer.allocate(40960);
									byte_body = buffer_body.array();
									channel.read(buffer_body);
									partMsg = new String(byte_body).trim();
									jsonPosition = buffer_body.position();
									bodyLength -= jsonPosition;
									if (partMsg.length() != 0) {
										oneJsonMsg = oneJsonMsg + partMsg;
									}
								}
							}
						}
					} else if (key.isReadable() && (System.currentTimeMillis() - timeOut) >= 5000) {// ---直接断开重连(即Json未读完整条)---
						recvMessageResult = CHONGLIAN;
					}
				}
			} else if (select_recvInt == 0 && !loopMark) { // ---发送get_allRobot_info;
															// 可能未接收到信息吧
															// 没有接到整条Json;
				loopTime++;
				if (loopTime >= 0 && loopTime < tryReSend) { // 当收到
					recvMessageResult = CHONGFA;
				}
				if (loopTime >= tryReSend) {
					recvMessageResult = CHONGLIAN;
				}
			}
		} catch (java.net.ConnectException e) {
			recvMessageResult = CHONGLIAN;
		} catch (java.lang.IllegalArgumentException e) {
			recvMessageResult = CHONGLIAN;
		} catch (java.nio.channels.ClosedChannelException e) {
			recvMessageResult = CHONGLIAN;
		} catch (java.nio.channels.CancelledKeyException e) {
			recvMessageResult = CHONGLIAN;
		} catch (IOException e) {
			recvMessageResult = CHONGLIAN;
		} catch (java.util.ConcurrentModificationException e) {
			recvMessageResult = CHONGLIAN;
		} catch (java.util.NoSuchElementException e) {
			recvMessageResult = CHONGLIAN;
		} catch (java.lang.NullPointerException e) {
			recvMessageResult = CHONGLIAN;
		} catch (java.lang.AssertionError error) {
			recvMessageResult = CHONGLIAN;
		} catch (java.nio.channels.NotYetConnectedException e) {
			recvMessageResult = CHONGLIAN;
		}
		return recvMessageResult;
	}

	/**
	 * 具体处理一条JSon信息
	 */
	private static String executeDealwithMessage() {

		String dealJsonResult = "";
		// Log.i("bcx_test=>oneJsonMsg", oneJsonMsg + ";;;");
		try {
			if (oneJsonMsg.contains("\"all_robot_info\"")) {
				// dealWith_all_robot_info();
				System.out.println(oneJsonMsg);
			} else if (oneJsonMsg.contains("\"report_basic_status\"")) {
				// dealWith_report_basic_status();
			} else if (oneJsonMsg.contains("\"report_move_status\"")) {
				// dealWith_report_move_status();
			} else if (oneJsonMsg.contains("\"report_loc_status\"")) {
				// dealWith_report_loc_status();
			} else if (oneJsonMsg.contains("\"report_pos_vel_status\"")) {
				// dealWith_report_pos_vel_status();
			} else if (oneJsonMsg.contains("\"report_obd_status\"")) {
				// dealWith_report_obd_status();
			} else if (oneJsonMsg.contains("\"report_charge_status\"")) {
				// dealWith_report_charge_status();
			} else if (oneJsonMsg.contains("\"laser\"")) {
				// dealWith_laser();
			} else if (oneJsonMsg.contains("\"uwb\"")) {
				// dealWith_uwb();
			} else if (oneJsonMsg.contains("\"sonar\"")) {
				// dealWith_sonar();
			} else if (oneJsonMsg.contains("\"update_map\"")) {
				// dealWith_update_map();
			} else if (oneJsonMsg.contains("\"real_path\"")) {
				// dealWith_real_path();
			} else if (oneJsonMsg.contains("\"local_path\"")) {
				// dealWith_local_path();
			} else if (oneJsonMsg.contains("\"update_file\"")) {
				if (!oneJsonMsg.contains("\"thumbnail.png\"")) {
					// dealWith_update_file();
				}
				if (oneJsonMsg.contains("\"thumbnail.png\"")) {
					// dealWith_thumbnail();
				}
			} else if (oneJsonMsg.contains("\"all_file_info\"")) {
				// dealWith_all_file_info(context);
			} else if (oneJsonMsg.contains("\"report_stat\"")) {
				// dealWith_report_stat();
			} else if (oneJsonMsg.contains("\"register_status\"")) {
				// dealWith_register_status();
			} else if (oneJsonMsg.contains("\"system_message\"")) {
				// dealWith_system_message();
			} else if (oneJsonMsg.contains("\"report_change_password_result\"")) {
				// dealWith_report_change_password_result();
			} else if (oneJsonMsg.contains("\"report_fault_code\"")) {
				// dealWith_report_fault_code();
			} else if (oneJsonMsg.contains("\"all_map_info\"")) {
				// dealWith_all_map_info();
			}

			if ("".equals(oneJsonMsg)) {
				nullTime++;
				if (nullTime > 3) {
					if (!OVERTIMESTATUS.equals(CONNSTATUS)) {
						CONNSTATUS = OVERTIMESTATUS;
					}
					sendGet_all_robot_info();
					nullTime = 0;
				}
			} else {
				if (!NORMALSTATUS.equals(CONNSTATUS)) {
					CONNSTATUS = NORMALSTATUS;
				}
			}
		} catch (Exception e) {
			dealJsonResult = CHONGLIAN;
		}
		return dealJsonResult;
	}

	/**
	 * TCP的完整流程
	 */
	public static void doTCPLoop(String robotIP, String username, String pwd, String salt) {
		MainLoop: while (loopMark) { // 主循环(用于重连)
			innerLoop = true;
			nullTime = 0;
			loopTime = 0;

			/**
			 * connection
			 */
			String connResult = executeConn(robotIP, username, pwd, salt); // ****请求连接connection****
			if (isSendReconn) { // 上层需要重连
				if (CHONGLIAN.equals(connResult)) { // 异常发生
					try {
						Thread.sleep(reconnTime);
						if (!EXCEPTIONSTATUS.equals(CONNSTATUS)) {
							CONNSTATUS = EXCEPTIONSTATUS;
						}
						continue; // 重连
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			}
			if (!isSendReconn) { // 否则 即上层不需要重连
				loopMark = false; // 断开主循环
				break; // 断开TCP连接
			}
			if (NORMAL.equals(connResult)) { // 正常 不做处理

			}

			/**
			 * process
			 */
			String processResult = executeProcess(username, pwd, salt); // ****请求过程process****
			if (isSendReconn) {
				if (CHONGLIAN.equals(processResult)) { // 异常发生
					// 上层需要重连
					try {
						Thread.sleep(reconnTime);
						if (!EXCEPTIONSTATUS.equals(CONNSTATUS)) {
							CONNSTATUS = EXCEPTIONSTATUS;
						}
						continue; // 重连
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			}
			if (!isSendReconn) { // 否则 即上层不需要重连
				loopMark = false; // 断开主循环
				break; // 断开TCP连接
			}

			/**
			 * prepare
			 */
			String recvPrepareResult = executeRecvPrepare(); // ****接收准备(防止channel被多次注册)****

			if (isSendReconn) { // 上层需要重连
				if (CHONGLIAN.equals(recvPrepareResult)) {
					try {
						Thread.sleep(reconnTime);
						if (!EXCEPTIONSTATUS.equals(CONNSTATUS)) {
							CONNSTATUS = EXCEPTIONSTATUS;
						}
						continue; // 重连
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			}
			if (!isSendReconn) { // 否则 即上层不需要重连
				loopMark = false; // 断开主连接
				break; // 断开TCP连接
			}

			SingleLoop: while (innerLoop) { // ****接收消息的循环(循环一条条Json)****
				oneJsonMsg = "";
				timeOut = System.currentTimeMillis();

				/**
				 * recv
				 */
				String RecvResult = executeRecvMessage(robotIP, username, pwd, salt); // ****接收消息(Json)****
				if (isSendReconn) { // 上层需要重连
					if (CHONGLIAN.equals(RecvResult)) { // 异常发生
						// 上层需要重连
						try {
							Thread.sleep(reconnTime);
							innerLoop = false;
							if (!EXCEPTIONSTATUS.equals(CONNSTATUS)) {
								CONNSTATUS = EXCEPTIONSTATUS;
							}
							break; // 重连
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}
					if (CHONGFA.equals(RecvResult)) { // 异常发生(重发)---(select=0)
						sendGet_all_robot_info(); // 重发get_allRobot_info
						if (!OVERTIMESTATUS.equals(CONNSTATUS)) {
							CONNSTATUS = OVERTIMESTATUS;
						}
						break; // 继续执行内层循环
					}
				}
				if (!isSendReconn) { // 上层不需要重连
					innerLoop = false;
					loopMark = false;
					break;
				}
				/**
				 * dealwithMsg
				 */
				String dealJsonResult = executeDealwithMessage(); // ****处理消息(Json)****
				if (isSendReconn) { // 上层需要重连
					if (CHONGLIAN.equals(dealJsonResult)) { // 异常发生
						try {
							Thread.sleep(reconnTime);
							innerLoop = false; // 断开内层循环
							if (!EXCEPTIONSTATUS.equals(CONNSTATUS)) {
								CONNSTATUS = EXCEPTIONSTATUS;
							}
							break; // 重连
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}
				}
				if (!isSendReconn) { // 否则 即上层不需要重连
					loopMark = false; // 断开主连接
					innerLoop = false; // 断开内层循环
					break; // 断开TCP连接
				}
				oneJsonMsg = "";
				timeOut = System.currentTimeMillis(); // 收完Json后重新计时
			}
		}
	}

	/**
	 * 获取所有机器人信息
	 */
	public static void sendGet_all_robot_info() {
		sendContents = "{\"message_type\":\"get_all_robot_info\"}";
		SendUtil.send(sendContents, channel);
	}

}
