package com.boocax.client.tcp.help;

import java.io.ByteArrayInputStream;

/**
 * 	消息头的转化
 */
public class Transition {
	/**
	 * （server==>APP）将接收到的前四字节转化成int类型，用来截取出Json的实际长度
	 *
	 * @param byte1
	 * @return
	 */
	public static int byte_to_int(byte[] byte1) {
		int length = 0;
		int num1 = byte1[0] & 0xFF;
		int num2 = ((byte1[1] << 8) & 0xFF00);
		int num3 = ((byte1[2] << 16) & 0xFF0000);
		int num4 = ((byte1[3] << 24) & 0xFF000000);
		length = num1 + num2 + num3 + num4;
		return length;
	}

	/**
	 * (APP==>Server)将要发送给server的String命令转化成byte[]
	 *
	 * @param request
	 * @return
	 */
	public static byte[] string_to_byte(String request) {
		int int_register = new ByteArrayInputStream(request.getBytes()).available();
		// 计算出String类型的数据转化成流 这个流的长度
		byte[] bytes = new byte[4];
		bytes[0] = (byte) (int_register % 256);
		bytes[1] = (byte) ((int_register / 256) % 256);
		bytes[2] = (byte) (((int_register / 256) / 256) % 256);
		bytes[3] = (byte) (((int_register / 256) / 256) / 256);
		return bytes;
	}
}
