package com.boocax.client.udp;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetSocketAddress;
import java.net.SocketException;
import java.util.ArrayList;
import java.util.List;

/**
 * 接受UDP广播用来区分和选择服务器；
 */
public class UDP_CONN {

	private static boolean isUDP = false;

	public static void getUDPs() {
		DatagramSocket socket = null;
		DatagramPacket packet = null;
		String UDPInfoStr = null;
		String str_serverName = null; // 服务器名称
		String str_serverIP = null; // 服务器IP
		String str_lock = null; // 服务器是否含有锁(直接登录还是需要用户名和密码来登录)
		List<String> udpInfoList;

		try {
			if (socket == null) {
				socket = new DatagramSocket(null);
				socket.setReuseAddress(true);
				socket.bind(new InetSocketAddress(6789));
			}
			byte data[] = new byte[1024];
			packet = new DatagramPacket(data, data.length);
			while (!isUDP) {
				socket.receive(packet);
				UDPInfoStr = new String(packet.getData(), packet.getOffset(), packet.getLength());

				if (UDPInfoStr.contains(":")) { // 如果含有":",代表是新版本的底盘(目前均为新版本底盘)
					String[] split = UDPInfoStr.split(":");
					if (split.length == 2) { // 服务器无用户名密码,注册时可省略
						str_serverName = split[1];
						str_lock = "false";

					} else if (split.length == 3) {// 服务器用用户名密码,注册需用
						str_serverName = split[2];
						str_lock = "true";
					}
					str_serverIP = packet.getAddress().getHostAddress();
					udpInfoList = new ArrayList();
					udpInfoList.add(str_serverName);
					udpInfoList.add(str_serverIP);
					udpInfoList.add(str_lock);
					// str_serverName,str_serverIP,str_lock请按上述方式解析
					System.out.println(udpInfoList.toString());
				}
			}
		} catch (SocketException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		getUDPs();
	}
}
